part of 'index.dart';

class VidImageViewController {
  bool hasBound = false;
  VidDataHost? _dataHost;
  State<VidImageView>? _state;
  Uint8List? _currentImgBuffer;

  Uint8List? get currentImageBuffer => _currentImgBuffer;

  Future<Uint8List?> getImageBytes() async {
    final frame = await _dataHost?.getFrame(0);
    _currentImgBuffer = frame?.imageData;
    return _currentImgBuffer;
  }

  void _bind(State<VidImageView> state) {
    if (hasBound) {
      throw FlutterError(
          "[VidImageViewController] cannot be bound to more then one `State`s at the same time.");
    }
    _state = state;
    hasBound = true;
    _dataHost = VidDataHost(_state!.widget.url);
  }

  Future<bool> loadSource() async {
    final info = await _dataHost!.load();
    return info != null;
  }

  void _release() {
    _dataHost?.release();
    _dataHost = null;
    _state = null;
    hasBound = false;
  }
}
