import 'package:fis_ui/define.dart';
import 'package:fis_ui/index.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/widgets.dart';

/// 按钮(按下时抬高) from Material
class FElevatedButton extends ElevatedButton implements FWidget {
  FElevatedButton({
    Key? key,
    required FWidget child,
    required VoidCallback? onPressed,
    ButtonStyle? style,
  }) : super(
          key: key,
          child: child,
          onPressed: onPressed,
          style: style,
        );
}

/// 轮廓按钮 from Material
class FOutlinedButton extends OutlinedButton implements FWidget {
  FOutlinedButton({
    Key? key,
    required FWidget child,
    required VoidCallback? onPressed,
    ButtonStyle? style,
  }) : super(
          key: key,
          child: child,
          onPressed: onPressed,
          style: style,
        );
}

/// 文本按钮 from Material
class FTextButton extends TextButton implements FWidget {
  FTextButton({
    Key? key,
    required FWidget child,
    required VoidCallback? onPressed,
    ButtonStyle? style,
  }) : super(
          key: key,
          child: child,
          onPressed: onPressed,
          style: style,
        );
}

/// 图标按钮 from Material
class FIconButton extends IconButton implements FWidget {
  FIconButton({
    Key? key,
    double iconSize = 24.0,
    EdgeInsetsGeometry padding = const EdgeInsets.all(8.0),
    AlignmentGeometry alignment = Alignment.center,
    double? splashRadius,
    required FWidget icon,
    Color? color,
    Color? focusColor,
    Color? hoverColor,
    Color? highlightColor,
    Color? splashColor,
    Color? disabledColor,
    required VoidCallback onPressed,
    MouseCursor mouseCursor = SystemMouseCursors.click,
  }) : super(
          key: key,
          icon: icon,
          onPressed: onPressed,
          iconSize: iconSize,
          padding: padding,
          alignment: alignment,
          splashRadius: splashRadius,
          color: color,
          focusColor: focusColor,
          hoverColor: hoverColor,
          highlightColor: highlightColor,
          splashColor: splashColor,
          disabledColor: disabledColor,
          mouseCursor: mouseCursor,
        );
}
