import 'package:fis_ui/define.dart';
import 'package:flutter/widgets.dart';

typedef FFormFieldBuilder<T> = FWidget Function(FormFieldState<T> field);

/// 表单控件
class FForm extends Form implements FWidget {
  FForm({
    Key? key,
    required FWidget child,
    WillPopCallback? onWillPop,
    VoidCallback? onChanged,
    AutovalidateMode? autovalidateMode,
  }) : super(
          key: key,
          child: child,
          onWillPop: onWillPop,
          onChanged: onChanged,
          autovalidateMode: autovalidateMode,
        );
}

/// 表单字段
class FFormField<T> extends FormField<T> implements FWidget {
  FFormField({
    Key? key,
    required FFormFieldBuilder builder,
    FormFieldSetter<T>? onSaved,
    FormFieldValidator<T>? validator,
    T? initialValue,
    bool enabled = true,
    AutovalidateMode? autovalidateMode,
  }) : super(
          key: key,
          builder: builder,
          onSaved: onSaved,
          validator: validator,
          initialValue: initialValue,
          enabled: enabled,
          autovalidateMode: autovalidateMode,
        );
}
